'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

exports.default = function () {
  for (var _len = arguments.length, options = Array(_len), _key = 0; _key < _len; _key++) {
    options[_key] = arguments[_key];
  }

  if (options.length === 1 && typeof options[0] === 'function') return Alignment.apply(null, [[], options[0]]);
  return Alignment.bind(null, options);
};

var _react = require('react');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function Alignment(options, ComposedComponent) {
  var _class, _temp;

  var allowedValues = ['left', 'right', 'center'];

  return _temp = _class = function (_ComposedComponent) {
    _inherits(_class, _ComposedComponent);

    function _class() {
      _classCallCheck(this, _class);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(_class).apply(this, arguments));
    }

    _createClass(_class, [{
      key: 'hasAlignment',
      value: function hasAlignment() {
        return this.props.horizontalAlignment !== undefined || this.props.verticalAlignment !== undefined;
      }
    }, {
      key: 'render',
      value: function render() {
        if (this.hasAlignment()) {
          var el = _get(Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
          var props = _extends({}, _get(Object.getPrototypeOf(_class.prototype), 'render', this).call(this).props);

          if (!props.style) props.style = {};
          for (var prop in props) {
            if (props.hasOwnProperty(prop)) {
              if (['horizontalAlignment', 'verticalAlignment'].indexOf(prop) !== -1) {
                if (allowedValues.indexOf(props[prop]) === -1) {
                  console.error('Unknown value for ' + prop + ': ' + props[prop]);
                } else if (prop === 'horizontalAlignment') {
                  switch (props[prop]) {
                    case 'center':
                      props.style.justifyContent = 'center';
                      break;
                    case 'left':
                      props.style.justifyContent = 'flex-start';
                      break;
                    case 'right':
                      props.style.justifyContent = 'flex-end';
                      break;
                  }
                } else if (prop === 'verticalAlignment') {
                  switch (props[prop]) {
                    case 'center':
                      props.style.alignItems = 'center';
                      break;
                    case 'left':
                      props.style.alignItems = 'flex-start';
                      break;
                    case 'right':
                      props.style.alignItems = 'flex-end';
                      break;
                  }
                }
                delete props[prop];
              }
            }
          }

          return (0, _react.cloneElement)(el, props);
        }
        return _get(Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      }
    }]);

    return _class;
  }(ComposedComponent), _class.propTypes = _extends({}, ComposedComponent.propTypes, {
    horizontalAlignment: _react.PropTypes.string,
    verticalAlignment: _react.PropTypes.string
  }), _temp;
}